Index: palm/trunk/SOURCE/virtual_measurement_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 3703)
+++ palm/trunk/SOURCE/virtual_measurement_mod.f90	(revision 3704)
@@ -20,12 +20,11 @@
 ! Current revisions:
 ! -----------------
-! 
+! - initialization revised
+! - binary data output
+! - list of allowed variables extended
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
-! unused variables removed
-! 
-! 3522 2018-11-13 12:14:36Z suehring
 ! Sampling of variables
 ! 
@@ -44,5 +43,5 @@
 !> The module acts as an interface between 'real-world' observations and 
 !> model simulations. Virtual measurements will be taken in the model at the
-!> coordinates representative for the 'real-world' measurement positions. 
+!> coordinates representative for the 'real-world' observation coordinates. 
 !> More precisely, coordinates and measured quanties will be read from a
 !> NetCDF file which contains all required information. In the model, 
@@ -53,6 +52,4 @@
 !>
 !> @todo list_of_allowed variables needs careful checking
-!> @todo output (binary or NetCDF) needs to be implemented
-!> @todo clean-up anything from current test modus
 !> @todo Check if sign of surface fluxes for heat, radiation, etc., follows
 !>       the (UC)2 standard 
@@ -71,6 +68,6 @@
         
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, dz, humidity, neutral, message_string,           &
-               virtual_measurement
+        ONLY:  air_chemistry, dz, humidity, io_blocks, io_group, neutral,      &
+               message_string, time_since_reference_point, virtual_measurement
 
     USE cpulog,                                                                &
@@ -81,40 +78,75 @@
 
     USE indices,                                                               &
-        ONLY:  nzb, nzt, nxl, nxr, nys, nyn, nx, ny
+        ONLY:  nzb, nzt, nxl, nxr, nys, nyn, nx, ny, wall_flags_0
 
     USE kinds
+    
+    USE netcdf_data_input_mod,                                                 &
+        ONLY:  init_model
+        
+    USE pegrid
+    
+    USE surface_mod,                                                           &
+        ONLY:  surf_lsm_h, surf_usm_h
+        
+    USE land_surface_model_mod,                                                &
+        ONLY:  nzb_soil, nzs, nzt_soil, zs, t_soil_h, m_soil_h 
+        
+    USE radiation_model_mod
+        
+    USE urban_surface_mod,                                                     &
+        ONLY:  nzb_wall, nzt_wall, t_wall_h 
 
 
     IMPLICIT NONE
+    
+    TYPE virt_general
+       INTEGER(iwp) ::  id_vm     !< NetCDF file id for virtual measurements
+       INTEGER(iwp) ::  nvm = 0   !< number of virtual measurements
+    END TYPE virt_general
 
     TYPE virt_mea
     
-       CHARACTER(LEN=100)  ::  feature_type  !< type of the measurement
-       CHARACTER(LEN=100)  ::  site          !< name of the measurement site
+       CHARACTER(LEN=100)  ::  feature_type      !< type of the measurement
+       CHARACTER(LEN=100)  ::  filename_original !< name of the original file
+       CHARACTER(LEN=100)  ::  site              !< name of the measurement site
    
        CHARACTER(LEN=10), DIMENSION(:), ALLOCATABLE ::  measured_vars_name !< name of the measured variables
     
-       INTEGER(iwp) ::  ns = 0 !< total number of observation points for a site on subdomain, i.e. sum of all trajectories
-       INTEGER(iwp) ::  ntraj  !< number of trajectories of a measurement
-       INTEGER(iwp) ::  nvar   !< number of measured variables
+       INTEGER(iwp) ::  ns = 0          !< number of observation coordinates on subdomain, for atmospheric measurements
+       INTEGER(iwp) ::  ns_tot = 0      !< total number of observation coordinates, for atmospheric measurements
+       INTEGER(iwp) ::  ntraj           !< number of trajectories of a measurement
+       INTEGER(iwp) ::  nvar            !< number of measured variables (atmosphere + soil)
+       
+       INTEGER(iwp) ::  ns_soil = 0     !< number of observation coordinates on subdomain, for soil measurements
+       INTEGER(iwp) ::  ns_soil_tot = 0 !< total number of observation coordinates, for soil measurements
        
        INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  dim_t !< number observations individual for each trajectory or station that are no _FillValues
        
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i  !< grid index for measurement position in x-direction
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j  !< grid index for measurement position in y-direction
-       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k  !< grid index for measurement position in k-direction
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i       !< grid index for measurement position in x-direction
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j       !< grid index for measurement position in y-direction
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k       !< grid index for measurement position in k-direction
+       
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i_soil  !< grid index for measurement position in x-direction
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j_soil  !< grid index for measurement position in y-direction
+       INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k_soil  !< grid index for measurement position in k-direction
            
        LOGICAL ::  trajectory         = .FALSE. !< flag indicating that the observation is a mobile observation
        LOGICAL ::  timseries          = .FALSE. !< flag indicating that the observation is a stationary point measurement
        LOGICAL ::  timseries_profile  = .FALSE. !< flag indicating that the observation is a stationary profile measurement
+       LOGICAL ::  soil_sampling      = .FALSE. !< flag indicating that soil state variables were sampled
        
-       REAL(wp) ::  fill_eutm                         !< fill value for UTM coordinates in case of missing values
-       REAL(wp) ::  fill_nutm                         !< fill value for UTM coordinates in case of missing values
-       REAL(wp) ::  fill_zag                          !< fill value for heigth coordinates in case of missing values 
-       REAL(wp) ::  fillout = -999.9                  !< fill value for output in case a observation is taken from inside a building 
-       REAL(wp) ::  origin_x_obs                      !< origin of the observation in UTM coordiates in x-direction
-       REAL(wp) ::  origin_y_obs                      !< origin of the observation in UTM coordiates in y-direction
+       REAL(wp) ::  fill_eutm          !< fill value for UTM coordinates in case of missing values
+       REAL(wp) ::  fill_nutm          !< fill value for UTM coordinates in case of missing values
+       REAL(wp) ::  fill_zag           !< fill value for heigth coordinates in case of missing values 
+       REAL(wp) ::  fillout = -999.9   !< fill value for output in case a observation is taken from inside a building 
+       REAL(wp) ::  origin_x_obs       !< origin of the observation in UTM coordiates in x-direction
+       REAL(wp) ::  origin_y_obs       !< origin of the observation in UTM coordiates in y-direction
+       
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  z_ag           !< measurement height above ground level
+       REAL(wp), DIMENSION(:), ALLOCATABLE   ::  depth          !< measurement depth in soil
              
-       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  measured_vars  !< measured variables 
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  measured_vars       !< measured variables 
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  measured_vars_soil  !< measured variables 
        
     END TYPE virt_mea
@@ -122,4 +154,8 @@
     CHARACTER(LEN=5)  ::  char_eutm = "E_UTM"                      !< dimension name for UTM coordinate easting
     CHARACTER(LEN=11) ::  char_feature = "featureType"             !< attribute name for feature type
+    
+    ! This need to generalized
+    CHARACTER(LEN=8)  ::  char_filename = "filename"               !< attribute name for filename
+    CHARACTER(LEN=11) ::  char_soil = "soil_sample"                !< attribute name for soil sampling indication
     CHARACTER(LEN=10) ::  char_fillvalue = "_FillValue"            !< variable attribute name for _FillValue 
     CHARACTER(LEN=18) ::  char_mv = "measured_variables"           !< variable name for the array with the measured variable names
@@ -133,7 +169,25 @@
     CHARACTER(LEN=10) ::  type_traj = 'trajectory'                 !< name of line measurements
     CHARACTER(LEN=17) ::  type_tspr = 'timeSeriesProfile'          !< name of stationary profile measurements
+    
+    CHARACTER(LEN=6), DIMENSION(1:5) ::  soil_vars       = (/                  & !< list of soil variables
+                            't_soil',                                          &
+                            'm_soil',                                          &
+                            'lwc   ',                                          &
+                            'lwcs  ',                                          &
+                            'smp   '                       /)
+                            
+    CHARACTER(LEN=10), DIMENSION(0:1,1:8) ::  chem_vars = RESHAPE( (/          &
+                                              'mcpm1     ', 'kc_PM1    ',      &
+                                              'mcpm2p5   ', 'kc_PM2.5  ',      &
+                                              'mcpm25    ', 'kc_PM25   ',      &
+                                              'mcpm10    ', 'kc_PM10   ',      &
+                                              'mfno2     ', 'kc_NO2    ',      &
+                                              'mfno      ', 'kc_NO     ',      &
+                                              'tro3      ', 'kc_O3     ',      &
+                                              'mfco      ', 'kc_CO     '       &
+                                                                   /), (/ 2, 8 /) )
 !
 !-- MS: List requires careful revision!
-    CHARACTER(LEN=10), DIMENSION(1:47), PARAMETER ::  list_allowed_variables = & !< variables that can be sampled in PALM
+    CHARACTER(LEN=10), DIMENSION(1:54), PARAMETER ::  list_allowed_variables = & !< variables that can be sampled in PALM
        (/ 'hfls      ',  & ! surface latent heat flux (W/m2)
           'hfss      ',  & ! surface sensible heat flux (W/m2)
@@ -143,5 +197,4 @@
           'mcpm1     ',  & ! mass concentration of PM1 (kg/m3)
           'mcpm2p5   ',  & ! mass concentration of PM2.5 (kg/m3)
-          'mcpm10    ',  & ! mass concentration of PM10 (kg/m3)
           'mcpm10    ',  & ! mass concentration of PM10 (kg/m3)
           'mcco      ',  & ! mass concentration of CO (kg/m3)
@@ -173,8 +226,11 @@
           'tsoil     ',  & ! ? soil temperature - which depth?                                                                
           'u         ',  & ! u-component
+          'utheta    ',  & ! total eastward kinematic heat flux
           'ua        ',  & ! eastward wind (is there any difference to u?)
           'v         ',  & ! v-component
+          'vtheta    ',  & ! total northward kinematic heat flux
           'va        ',  & ! northward wind (is there any difference to v?)
           'w         ',  & ! w-component
+          'wtheta    ',  & ! total vertical kinematic heat flux
           'rld       ',  & ! downward longwave radiative flux (W/m2)
           'rlu       ',  & ! upnward longwave radiative flux (W/m2)
@@ -182,20 +238,21 @@
           'rsu       ',  & ! upward shortwave radiative flux (W/m2)
           'rsddif    ',  & ! downward shortwave diffuse radiative flux (W/m2)
-          'rnds      '   & ! surface net downward radiative flux (W/m2)
+          'rnds      ',  & ! surface net downward radiative flux (W/m2)
+          't_soil    ',  &
+          'm_soil    ',  &
+          'lwc       ',  &
+          'lwcs      ',  &
+          'smp       '   &
        /)
-                                                             
-    INTEGER(iwp) ::  id_vm                           !< NetCDF file id for virtual measurements
-    INTEGER(iwp) ::  nvm = 0                         !< number of virtual measurements
-!    INTEGER(iwp) ::  observation_coverage_xy = 0     !< horizontal distance from the measurement point where observations should be taken in the surrounding
-!    INTEGER(iwp) ::  observation_coverage_z  = 0     !< vertical distance from the measurement point where observations should be taken in the surrounding
-    
+                                                            
+    
+    LOGICAL ::  global_attribute = .TRUE.         !< flag indicating a global attribute
+    LOGICAL ::  init = .TRUE.                     !< flag indicating initialization of data output
     LOGICAL ::  use_virtual_measurement = .FALSE. !< Namelist parameter
-    LOGICAL ::  global_attribute = .TRUE.         !< flag indicating a global attribute
     
     REAL(wp) ::  vm_time_start = 0.0              !< time after virtual measurements should start
-    
-
+
+    TYPE( virt_general )                        ::  vmea_general !< data structure which encompass general variables
     TYPE( virt_mea ), DIMENSION(:), ALLOCATABLE ::  vmea !< virtual measurement data structure
-    
     
     INTERFACE vm_check_parameters
@@ -203,8 +260,16 @@
     END INTERFACE vm_check_parameters
     
+    INTERFACE vm_data_output
+       MODULE PROCEDURE vm_data_output
+    END INTERFACE vm_data_output
+    
     INTERFACE vm_init
        MODULE PROCEDURE vm_init
     END INTERFACE vm_init
     
+    INTERFACE vm_last_actions
+       MODULE PROCEDURE vm_last_actions
+    END INTERFACE vm_last_actions
+    
     INTERFACE vm_parin
        MODULE PROCEDURE vm_parin
@@ -221,9 +286,10 @@
 !
 !-- Public interfaces
-    PUBLIC  vm_check_parameters, vm_init, vm_parin, vm_sampling
+    PUBLIC  vm_check_parameters, vm_data_output, vm_init, vm_last_actions,     &
+            vm_parin, vm_sampling
 
 !
 !-- Public variables
-    PUBLIC  vmea, vm_time_start
+    PUBLIC  vmea, vmea_general, vm_time_start
 
  CONTAINS
@@ -251,5 +317,5 @@
 !-- ToDo: Revise this later and remove this requirement.
     IF ( virtual_measurement  .AND.  .NOT. input_pids_static )  THEN
-       message_string = 'If virtual measurements are taken a static input ' // &
+       message_string = 'If virtual measurements are taken, a static input ' //&
                         'file is mandatory.'
        CALL message( 'vm_check_parameters', 'PA0000', 1, 2, 0, 6, 0 )
@@ -319,5 +385,6 @@
  
     USE netcdf_data_input_mod,                                                 &
-        ONLY:  input_file_vm, netcdf_data_input_get_dimension_length,          &
+        ONLY:  init_model, input_file_vm,                                      &
+               netcdf_data_input_get_dimension_length,                         &
                netcdf_data_input_att, netcdf_data_input_var
                
@@ -328,17 +395,18 @@
     
     CHARACTER(LEN=5)    ::  dum                !< dummy string indicate station id
+    CHARACTER(LEN=5)    ::  dummy_read                !< dummy string indicate station id
     CHARACTER(LEN=10), DIMENSION(50) ::  measured_variables_file = '' !< array with all measured variables read from NetCDF
     CHARACTER(LEN=10), DIMENSION(50) ::  measured_variables      = '' !< dummy array with all measured variables that are allowed   
     
-!    INTEGER(iwp) ::  dim_eutm  !< dimension size of UTM easting coordinate
-!    INTEGER(iwp) ::  dim_nutm  !< dimension size of UTM northing coordinate
+    INTEGER(iwp) ::  dim_eutm  !< dimension size of UTM easting coordinate
+    INTEGER(iwp) ::  dim_nutm  !< dimension size of UTM northing coordinate
     INTEGER(iwp) ::  dim_ntime !< dimension size of time coordinate 
-!    INTEGER(iwp) ::  dim_zag   !< dimension size of height coordinate
-!    INTEGER(iwp) ::  i         !< grid index of virtual observation point in x-direction
-!    INTEGER(iwp) ::  ii        !< running index over all coordinate points of a measurement
+    INTEGER(iwp) ::  dim_zag   !< dimension size of height coordinate
+    INTEGER(iwp) ::  i         !< grid index of virtual observation point in x-direction
+    INTEGER(iwp) ::  ii        !< running index over all coordinate points of a measurement
     INTEGER(iwp) ::  is        !< grid index of real observation point of the respective station in x-direction
-!    INTEGER(iwp) ::  j         !< grid index of observation point in x-direction
+    INTEGER(iwp) ::  j         !< grid index of observation point in x-direction
     INTEGER(iwp) ::  js        !< grid index of real observation point of the respective station in y-direction
-!    INTEGER(iwp) ::  k         !< grid index of observation point in x-direction
+    INTEGER(iwp) ::  k         !< grid index of observation point in x-direction
     INTEGER(iwp) ::  kl        !< lower vertical index of surrounding grid points of an observation coordinate
     INTEGER(iwp) ::  ks        !< grid index of real observation point of the respective station in z-direction
@@ -352,4 +420,9 @@
     INTEGER(iwp) ::  ns        !< counter variable for number of observation points on subdomain
     INTEGER(iwp) ::  t         !< running index over number of trajectories
+    INTEGER(iwp) ::  m
+    
+    INTEGER(KIND=1)::  soil_dum
+    
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ns_all !< dummy array used to sum-up the number of observation coordinates
     
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  meas_flag !< mask array indicating measurement positions
@@ -366,24 +439,28 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  z_ag  !< height coordinate relative to origin_z, temporary variable
 !
-!-- Obtain number of virtual measurement stations
-    CALL netcdf_data_input_att( nvm, char_numstations, id_vm, input_file_vm,   &
+!-- Obtain number of sites. Also, pass the 'open' string, in order to initially
+!-- open the measurement driver. 
+    CALL netcdf_data_input_att( vmea_general%nvm, char_numstations,            &
+                                vmea_general%id_vm, input_file_vm,             &
                                 global_attribute, 'open', '' )
                                 
-!     write(9,*) "num stationi", nvm
-!     flush(9)
-!
-!-- ALLOCATE data structure
-    ALLOCATE( vmea(1:nvm) )
-!
-!-- Allocate flag array
+!
+!-- Allocate data structure which encompass all required information, such as
+!-- grid points indicies, absolute UTM coordinates, the measured quantities, 
+!-- etc. .
+    ALLOCATE( vmea(1:vmea_general%nvm) )
+!
+!-- Allocate flag array. This dummy array is used to identify grid points
+!-- where virtual measurements should be taken. Please note, at least one 
+!-- ghost point is required, in order to include also the surrounding 
+!-- grid points of the original coordinate.  
     ALLOCATE( meas_flag(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) )
     meas_flag = 0
- 
-!
-!-- Read station coordinates and further attributes. 
-!-- Note all coordinates are in UTM coordinates.
-    DO  l = 1, nvm
-!
-!--    Determine suffix which contains the ID
+!
+!-- Loop over all sites.
+    DO  l = 1, vmea_general%nvm
+!
+!--    Determine suffix which contains the ID, ordered according to the number
+!--    of measurements. 
        IF( l < 10 )  THEN
           WRITE( dum, '(I1)')  l
@@ -397,18 +474,36 @@
           WRITE( dum, '(I5)')  l
        ENDIF
-       
-       CALL netcdf_data_input_att( vmea(l)%origin_x_obs, char_origx            &
-                                   // TRIM( dum ), id_vm, '', global_attribute,&
+!
+!--    Read site coordinates (UTM).
+       CALL netcdf_data_input_att( vmea(l)%origin_x_obs, char_origx //         &
+                                   TRIM( dum ), vmea_general%id_vm, '',        &
+                                   global_attribute, '', '' )
+       CALL netcdf_data_input_att( vmea(l)%origin_y_obs, char_origy //         &
+                                   TRIM( dum ), vmea_general%id_vm, '',        &
+                                   global_attribute, '', '' )
+!
+!--    Read site name                  
+       CALL netcdf_data_input_att( vmea(l)%site, char_site // TRIM( dum ),     &
+                                   vmea_general%id_vm, '', global_attribute,   &
                                    '', '' )
-       CALL netcdf_data_input_att( vmea(l)%origin_y_obs, char_origy            &
-                                   // TRIM( dum ), id_vm, '', global_attribute,&
+!
+!--    Read type of the measurement (trajectory, profile, timeseries).
+       CALL netcdf_data_input_att( vmea(l)%feature_type, char_feature //       &
+                                   TRIM( dum ), vmea_general%id_vm, '',        &
+                                   global_attribute, '', '' )
+!
+!--    Read the name of the original file where observational data is stored. 
+       CALL netcdf_data_input_att( vmea(l)%filename_original, char_filename // &
+                                   TRIM( dum ), vmea_general%id_vm, '',        &
+                                   global_attribute, '', '' )
+!
+!--    Read a flag which indicates that also soil quantities are take at the 
+!--    respective site (is part of the virtual measurement driver).  
+       CALL netcdf_data_input_att( soil_dum, char_soil // TRIM( dum ),         &
+                                   vmea_general%id_vm, '', global_attribute,   &
                                    '', '' )
-       CALL netcdf_data_input_att( vmea(l)%site,         char_site             &
-                                   // TRIM( dum ), id_vm, '', global_attribute,&
-                                   '', '' )
-       CALL netcdf_data_input_att( vmea(l)%feature_type, char_feature          &
-                                   // TRIM( dum ), id_vm, '', global_attribute,&
-                                   '', '' )
-       
+!
+!--    Set flag for soil-sampling.
+       IF ( soil_dum == 1 )  vmea(l)%soil_sampling = .TRUE.
 !
 !---   Set logicals depending on the type of the measurement
@@ -419,7 +514,7 @@
        ELSEIF ( INDEX( vmea(l)%feature_type, type_traj ) /= 0 )  THEN
           vmea(l)%trajectory        = .TRUE.
+!
+!--   Give error message in case the type matches non of the pre-defined types.
        ELSE
-!
-!--       Give error message
           message_string = 'Attribue featureType = ' //                        &
                            TRIM( vmea(l)%feature_type ) //                     &
@@ -428,16 +523,16 @@
        ENDIF
 !
-!--    Read string with all measured variables at this station
+!--    Read string with all measured variables at this site
        measured_variables_file = ''
        CALL netcdf_data_input_var( measured_variables_file,                    &
-                                   char_mv // TRIM( dum ), id_vm )
-!
-!--    Count the number of measured variables which match with the variables
-!--    which are allowed to be measured in PALM. Please note, for some 
-!--    NetCDF interal reasons characters end with a NULL, i.e. also empty 
-!--    characters contain a NULL. Therefore, check the strings for a Null to 
-!--    get the correct character length in order to compare them with the list
-!--    of allowed variables. 
-       vmea(l)%nvar = 0
+                                   char_mv // TRIM( dum ), vmea_general%id_vm )
+!
+!--    Count the number of measured variables. Only count variables that match
+!--    with the allowed variables. 
+!--    Please note, for some NetCDF interal reasons characters end with a NULL,
+!--    i.e. also empty characters contain a NULL. Therefore, check the strings
+!--    for a NULL to get the correct character length in order to compare 
+!--    them with the list of allowed variables. 
+       vmea(l)%nvar   = 0
        DO ll = 1, SIZE( measured_variables_file )
           IF ( measured_variables_file(ll)(1:1) /= CHAR(0)  .AND.              &
@@ -465,5 +560,5 @@
        ENDDO
 !
-!--    Allocate array for the measured variables names for the station l.
+!--    Allocate array for the measured variables names for the respective site.
        ALLOCATE( vmea(l)%measured_vars_name(1:vmea(l)%nvar) )
 
@@ -474,52 +569,56 @@
 !--    In case of chemistry, check if species is considered in the modelled
 !--    chemistry mechanism.
-       IF ( air_chemistry )  THEN
-          DO  ll = 1, vmea(l)%nvar
-             chem_include = .FALSE.
-             DO  n = 1, nspec
-                IF ( TRIM( vmea(l)%measured_vars_name(ll) ) ==                 &
-                     TRIM( chem_species(n)%name ) )  chem_include = .TRUE.
-             ENDDO
-             IF ( .NOT. chem_include )  THEN
-                message_string = TRIM( vmea(l)%measured_vars_name(ll) ) //     &
-                                 ' is not considered in the modelled '  //     &
-                                 'chemistry mechanism'
-                CALL message( 'vm_init', 'PA0000', 0, 0, 0, 6, 0 )
-             ENDIF
-          ENDDO
-       ENDIF
-!
-!--    For the actual measurement ID read the UTM coordinates. Based on these,
-!--    define the index space on each subdomain where measurements should be
-!--    taken. Note, the entire coordinate arrays will not be stored on data
-!--    type as this would exceed memory requirements, particularly for 
-!--    trajectory measurements. If no variable will be virtually measured, 
-!--    skip the reading. 
+!        IF ( air_chemistry )  THEN
+!           DO  ll = 1, vmea(l)%nvar
+!              chem_include = .FALSE.
+!              DO  n = 1, nspec
+!                 IF ( TRIM( vmea(l)%measured_vars_name(ll) ) ==                 &
+!                      TRIM( chem_species(n)%name ) )  chem_include = .TRUE.
+!              ENDDO
+! !
+! !--  Revise this. It should only check for chemistry variables and not for all!
+!              IF ( .NOT. chem_include )  THEN
+!                 message_string = TRIM( vmea(l)%measured_vars_name(ll) ) //     &
+!                                  ' is not considered in the modelled '  //     &
+!                                  'chemistry mechanism'
+!                 CALL message( 'vm_init', 'PA0000', 0, 0, 0, 6, 0 )
+!              ENDIF
+!           ENDDO
+!        ENDIF
+!
+!--    Read the UTM coordinates for the actual site. Based on the coordinates,
+!--    define the grid-index space on each subdomain where virtual measurements
+!--    should be taken. Note, the entire coordinate arrays will not be stored 
+!--    as this would exceed memory requirements, particularly for trajectory 
+!--    measurements. 
        IF ( vmea(l)%nvar > 0 )  THEN
 !
 !--       For stationary measurements UTM coordinates are just one value and 
 !--       its dimension is "station", while for mobile measurements UTM 
-!--       coordinates are arrays. First, inquire dimension length for 
-!--       UTM coordinates.
+!--       coordinates are arrays depending on the number of trajectories and
+!--       time, according to (UC)2 standard. First, inquire dimension length 
+!--       of the UTM coordinates.
           IF ( vmea(l)%trajectory )  THEN
 !
 !--          For non-stationary measurements read the number of trajectories
-             CALL netcdf_data_input_get_dimension_length( id_vm,              &
+!--          and the number of time coordinates.
+             CALL netcdf_data_input_get_dimension_length( vmea_general%id_vm, &
                                                           vmea(l)%ntraj,      &
                                                           "traj" //           &
                                                           TRIM( dum ) )
-             CALL netcdf_data_input_get_dimension_length( id_vm, dim_ntime,   &
+             CALL netcdf_data_input_get_dimension_length( vmea_general%id_vm, &
+                                                          dim_ntime,          &
                                                           "ntime" //          &
                                                           TRIM( dum ) )
 !
-!--       For stationary measurements the dimension for UTM coordinates is 1
+!--       For stationary measurements the dimension for UTM and time 
+!--       coordinates is 1. 
           ELSE
              vmea(l)%ntraj  = 1
              dim_ntime = 1
           ENDIF
-          
 !
 !-        Allocate array which defines individual time frame for each 
-!--       trajectory or station
+!--       trajectory or station.
           ALLOCATE( vmea(l)%dim_t(1:vmea(l)%ntraj) )
 !
@@ -530,13 +629,16 @@
           ALLOCATE( z_ag(1:vmea(l)%ntraj,1:dim_ntime)  )
 !
-!--       Read _FillValue attributes
+!--       Read _FillValue attributes of the coordinate dimensions.
           CALL netcdf_data_input_att( fill_eutm, char_fillvalue,               &
-                                      id_vm, '', .NOT. global_attribute, '',   &
+                                      vmea_general%id_vm, '',                  &
+                                      .NOT. global_attribute, '',              &
                                       char_eutm // TRIM( dum ) )
           CALL netcdf_data_input_att( fill_nutm, char_fillvalue,               &
-                                      id_vm, '', .NOT. global_attribute, '',   &
+                                      vmea_general%id_vm, '',                  &
+                                      .NOT. global_attribute, '',              &
                                       char_nutm // TRIM( dum ) )
           CALL netcdf_data_input_att( fill_zag, char_fillvalue,                &
-                                      id_vm, '', .NOT. global_attribute, '',   &
+                                      vmea_general%id_vm, '',                  &
+                                      .NOT. global_attribute, '',              &
                                       char_zag  // TRIM( dum ) )
 !
